(function () {
    "use strict";

    angular.module('core').controller('vendaVarejoDetailController', controller);
    controller.$inject = ['$scope', '$timeout', '$state', '$stateParams', 'vendaVarejoService', 'notaFiscalService', '$confirm'];

    function controller($scope, $timeout, $state, $stateParams, vendaVarejoService, notaFiscalService, $confirm) {
        $scope.initializeLayout('Venda de Varejo');

        //[Inicializa objetos]
        $scope.state = {
            item: { ID: decodeURIComponent($stateParams.id) },
            carregando: false,
            vazio: false,
            tabCorrente: 0,
            tabs: { Itens: 0, Detalhes: 1 },
        };
        $scope.popups = {
            item: {
                selectedIndex: -1,
                selectedItem: null,
            },
            gerarNota: {
                run: async () => {
                    try {

                        $scope.popups.cancelamento.processando = true;
                        debugger
                        const response = await vendaVarejoService.gerarNota($scope.state.item.ID);
                        debugger
                        if (response.Status < 0) { 
                                $scope.tools.toastr.error(response.Message);
                        } else {
                      
                            $scope.state.item = response.Data;
                            $scope.tools.toastr.success("Nota gerada com sucesso!");
                        }

                    } catch (error) {
                        $scope.tools.toastr.error("Não foi possível acessar o(s) servidor(es)");
                        console.error(error);
                    } finally {
                        $scope.popups.cancelamento.processando = false;
                        $scope.$digest();
                    }
                }
            },
            cancelamento: {
                ativo: false,
                processando: false,
                toggle: async () => {
                    $scope.popups.cancelamento.ativo = !$scope.popups.cancelamento.ativo;
                },
                run: async () => {
                    try {
                        if ($scope.popups.cancelamento.processando)
                            return;

                        $scope.popups.cancelamento.processando = true;

                        const response = await notaFiscalService.enviarCancelamentoSefaz($scope.state.item.NotaFiscal);
                        debugger
                        if (response.Status < 0) {
                            if (response.Status == -1) {

                                $confirm({ text: "A nota não pode ser cancelada, gostaria de cancelar somente a venda?" })
                                    .then(function () {
                                        $scope.popups.cancelamento.cancelarVenda();
                                    })
                                    .catch(function () {
                                        $scope.refresh();
                                    });
                            }
                            else
                                $scope.tools.toastr.error(response.Message);
                        } else {
                            $scope.popups.cancelamento.cancelarVenda();
                            $scope.state.item = response.Data;
                        }
                         
                    } catch (error) {
                        $scope.tools.toastr.error("Não foi possível acessar o(s) servidor(es)");
                        console.error(error);
                    } finally {
                        $scope.popups.cancelamento.processando = false;
                        $scope.$digest();
                    }
                },
                cancelarVenda: async () => {
                    try {

                        $scope.popups.cancelamento.processando = true;

                        const response = await vendaVarejoService.cancel($scope.state.item.ID);
                        debugger
                        if (response.Status < 0) {
                            if (response.Status == -3) {
                                $confirm({ text: "A nota não pode ser cancelada, gostaria de cancelar somente a venda?" })
                                    .then(function () {
                                        $scope.confirmPagamento();
                                    });
                            }
                            $alert({ text: response.Message, title: $scope.Title });
                        } else {
                            $scope.state.item = response.Data;
                        }

                        $scope.popups.cancelamento.toggle();
                    } catch (error) {
                        $scope.tools.toastr.error("Não foi possível acessar o(s) servidor(es)");
                        console.error(error);
                    } finally {
                        $scope.popups.cancelamento.processando = false;
                        $scope.$digest();
                    }
                }
            },
        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();
        };

        $scope.get = function () {
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            vendaVarejoService
                .get($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.item = response.Data;
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = !$scope.state.item;
                    },
                    function (_error) {
                         
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.refresh = function () {
            $scope.get();
        };

        $scope.selectItem = function (index) {
            $scope.popups.item.selectedIndex = index;
            $scope.popups.item.selectedItem = $scope.state.item.Itens[$scope.popups.item.selectedIndex];
        }
        $scope.unselectItem = function () {
            $scope.popups.item.selectedIndex = -1;
            $scope.popups.item.selectedItem = null;
        };
        $scope.nextItem = function () {
            if ($scope.popups.item.selectedIndex < ($scope.state.item.Itens.length - 1)) {
                $scope.popups.item.selectedIndex++;
                $scope.popups.item.selectedItem = $scope.state.item.Itens[$scope.popups.item.selectedIndex];
            }
        };
        $scope.priorItem = function () {
            if ($scope.popups.item.selectedIndex > 0) {
                $scope.popups.item.selectedIndex--;
                $scope.popups.item.selectedItem = $scope.state.item.Itens[$scope.popups.item.selectedIndex];
            }
        };

        /*Inicializa funções*/
        $scope.initialize();

    }

})();